// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "Misc/FileHelper.h"
#include "Misc/Paths.h"
#include "Engine/Engine.h"
#include "OffAxisBlueprintFunctionLibrary.generated.h"

/**
 * 
 */

USTRUCT(BlueprintType)
struct FScreenData
{
	GENERATED_USTRUCT_BODY()

		UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		int32 id;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		FString name;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		FVector center;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		FRotator rot;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		FVector2D resolution;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		float width;
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "OffAxisProjection")
		float height;

};

UCLASS()
class OFFAXISPROJECTION_API UOffAxisBlueprintFunctionLibrary : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()
	
		UFUNCTION(BlueprintCallable, meta = (DisplayName = "Load Id", Keywords = "OffAxisProjection"), Category = "OffAxisProjection")
		static int32 LoadScreenId();

		UFUNCTION(BlueprintCallable, meta = (DisplayName = "Load Config", Keywords = "OffAxisProjection"), Category = "OffAxisProjection")
		static TArray<FScreenData> LoadConfig(FString filename);

		UFUNCTION(BlueprintCallable, meta = (DisplayName = "Write log", keywords = "OffAxisProjection"), Category = "OffAxisProjection")
		static void WriteLog();
	
	
};
